/* c3.c */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<arpa/inet.h>
#include<fcntl.h>
#include<sys/types.h>
#include<sys/socket.h>

#define BUFSIZE 1000000 
#define FILENAMESIZE 14

int get_file_from_server(char *file_name);
int put_file_to_server  (char *file_name);

void error_handling(char *message);

int sd;

int main(int argc, char **argv)
{
	
	struct sockaddr_in serv_addr;

	int snd_buf = 1000000;
	int rcv_buf = 1000000;
	
	FILE * fp; // pointer of list file
	int i, k, len;

	char file_name[256];
	char cast_name[256];
	char orig_name[256];
	char list_file_name[256];
	char only_file_name[FILENAMESIZE];
	char message_from_server[4];
	char put[4] = "put";
	char select;
	char temp;

	memset(file_name,           0, 256);
	memset(cast_name,           0, 256);
	memset(orig_name,           0, 256);
	memset(list_file_name,      0, 256);
	memset(only_file_name,      0,  14);
	memset(message_from_server, 0,   4);

// -----------------------------------------------------------------------------
	if(argc!=3)
	{
		printf("Usage : %s <IP> <port> \n", argv[0]);
		exit(1);
	}

	//     
	sd = socket(PF_INET, SOCK_STREAM, 0);
	if(sd == -1)
		error_handling("socket() error");

	setsockopt(sd, SOL_SOCKET, SO_SNDBUF, &snd_buf, sizeof(snd_buf));
	setsockopt(sd, SOL_SOCKET, SO_RCVBUF, &rcv_buf, sizeof(rcv_buf));

	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family=AF_INET;
	serv_addr.sin_addr.s_addr=inet_addr(argv[1]);
	serv_addr.sin_port=htons(atoi(argv[2]));

	if(connect(sd, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) == -1)
		error_handling("connect() error!");
// ---------------------------------------------------------------------------

	//   .
	//    ϵ  Ư  ִ´.
	//  Ʈ  openѴ.

	fp = fopen("org2cmp.txt", "r");
	if(fp == NULL) {
		error_handling("File open error");
	}
	
	while(fscanf(fp, "%s", &file_name) != EOF)
	{

		len = strlen(file_name);
		
		k = 0;  // [X][S] ڸ κ
		for(i = 3 ; i <= len ; i++)
		{
			cast_name[k] = file_name[i];
			k++;
		}
		k = 0;	//  ̸ θ  κ
		for(i = len - FILENAMESIZE ; i <= len ; i++)
		{
			orig_name[k] = file_name[i];
			k++;
		}		
		if(file_name[1] == 'X')
		{
			send(sd, put, 4, 0);
			send(sd, orig_name, FILENAMESIZE+1, 0);
			put_file_to_server(cast_name);
		}
		else if (file_name[1] == 'S')
		{
// **********************************************************************************
// ̺κ  Ǵ° ϴ.
// select = 1 ϸ ƹ   ưµ
// scanf("%c", &select); ϸ ̻ ڰ ϴ.
// put̶ ڰ ޵Ǿ ϴµ ?; 00000009.vo ̷  Ǿ Ѥ;
//    ϰŵ..
			printf("Different size ! 1 - put, 2 - get : ");
			scanf("%c", &select);
			//select = '1';
			printf("%c\n", select);
// **********************************************************************************

			if(select == '1')
			{
				send(sd, put, 4, 0);
				printf("%s\n", put);
				printf("%s\n", orig_name);
				send(sd, orig_name, FILENAMESIZE+1, 0);
				put_file_to_server(cast_name);
			}
			else
			{	
				// ӽ  ./temp/̸.vox
				write(sd, "get", 4); // get ޽ .
				write(sd, cast_name, FILENAMESIZE+8); // [X][S]  ο ̸ .
				get_file_from_server(cast_name);
			}
		}
		else
		{
			error_handling("File name error");
		}
		
		fflush(fp);

	}

	write(sd, "end", 3); //    
		
	fclose(fp); //  κ  bind  .
		
// ----------------------------------------------------------------------------

	//     .
	put_file_to_server("cmp2org.txt");

// ----------------------------------------------------------------------------
	//    ޴´.
	// cmp2org  
	//   ޽  get_file_from_client put_file_to_client 
	while(1)
	{
		strcpy(file_name, "./cmp2org/"); //  Ư  ʱȭ
	
		read(sd, message_from_server, 4); // ɾ ޴´.
		
		if(strcmp(message_from_server, "put") == 0)
		{
			read(sd, only_file_name, FILENAMESIZE+1); //  ̸ ޴´.
			strcat(file_name, only_file_name); // εڿ ̸ δ.
			get_file_from_server(file_name);
		}
		//else if(strcmp(message_from_server, "get") == 0)
		//{
		//	//  ̸ ޴´.
		//	put_file_to_server(file_name);
		//}
		else if(strcmp(message_from_server, "end") == 0)
		{
			break;
		}
		else
		{
			error_handling("wrong message error");
		}
	
	}	
// ----------------------------------------------------------------------------

	//  ϴ κ
	close(sd);
	
// ----------------------------------------------------------------------------	
	return 0;

}

int get_file_from_server(char *file_name)
{
	int fd;
	int len;
	char buf[BUFSIZE];
	
	//  ͸   
	fd = open(file_name, O_WRONLY | O_CREAT | O_TRUNC, 00644);
	if(fd == -1)
		error_handling("File open error");

	len = read(sd, buf, BUFSIZE);
	
	write(fd, buf, len);

	write(sd, "client : complete\n", 20);
	close(fd);
	return 0;
	
}


int put_file_to_server(char *file_name)
{
	int fd;
	int len;
	char buf[BUFSIZE];
	
	// Ŭ̾Ʈ   Ѵ.
	fd = open(file_name, O_RDONLY, 00400);
	if(fd == -1) {
		error_handling("File open error");
	}

	// ŬƮ  
	len = read(fd, buf, BUFSIZE);
	write(sd, buf, len);


	// Ϸ ޼ Ѵ.
	len = read(sd, buf, 20); 
	write(1, buf, len);

	close(fd);
	return 0;
}

void error_handling(char *message)
{
  	fputs(message, stderr);
	fputc('\n', stderr);  
	exit(1);
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                
